version: "3.7"

services:
  nexad:
    image: nexa/nexa:v1.3.0.2
    command: nexad --printtoconsole=1 -debug=1 -zmqpubhashtx=tcp://*:28332 -zmqpubrawtx=tcp://*:28332 -zmqpubhashblock=tcp://*:28332 -zmqpubrawblock=tcp://*:28332 -txindex=1 -regtest -rpcbind=nexad -rpcallowip=0/0 -rpcuser=alice -rpcpassword=password
    # command: /bin/bash
    # stdin_open: true # docker run -i
    # tty: true        # docker run -t
    healthcheck:
      test: ["CMD", "/entrypoint.sh", "nexa-cli", "getblockchaininfo"]
      interval: 1m30s
      timeout: 10s
      retries: 3
      start_period: 10s
    container_name: nexad
    # ports:
    #   - "18332:18332" # rpc
    #   - "28332:28332" # zmq pub
    expose: [18332, 28332]
    volumes:
      - nexa-data:/data
  nexa-mine:
    image: nexa/nexa:v1.3.0.2
    entrypoint: ["/entrypoint.sh"]
    # privkey "207efc5233effadd4f2df00410526dc4d0ca901ca8f0b7a1e92a42d3baf14e7f"
    command: /bin/sh -c "/bin/sleep 3 && nexa-cli -regtest -rpcconnect=nexad  -rpcuser=alice -rpcpassword=password -rpcport=18332 generatetoaddress 150 nexareg:nqtsq5g58hfc66g93hccs83f3f0ykwpacx407zwz5jgytfc6 100000000 2> /dev/null && nexa-cli -regtest -rpcconnect=nexad  -rpcuser=alice -rpcpassword=password -rpcport=18332 generatetoaddress 150 nexareg:nqtsq5g5athh5a72rnmv5d0wkuvsj7de58lqmgpzrnkeagg3 100000000 2> /dev/null && nexa-cli -regtest -rpcconnect=nexad  -rpcuser=alice -rpcpassword=password -rpcport=18332 generatetoaddress 150 nexareg:nqtsq5g56jgtdfdp7gv7d9eaerx30rvm8epxmgr3zg0j8fh4 100000000 2> /dev/null"
  rostrum:
    image: nexa/rostrum:v9.1.0
    command: /bin/sh -c "/bin/sleep 10 && rostrum"
    ports:
      - "127.0.0.1:30401:30401"
      - "127.0.0.1:30403:30403"
    expose: [30401, 30403]
    depends_on:
      - nexa-mine
    volumes:
      - rostrum-data:/home/rostrum
      - nexa-data:/nexa-data/.nexa:ro
    environment:
      - ROSTRUM_VERSION=0
      - ROSTRUM_VERBOSE=4
      - ROSTRUM_TIMESTAMP=true
      - ROSTRUM_DB_DIR=/home/rostrum/db
      - ROSTRUM_NETWORK=regtest
      - ROSTRUM_DAEMON_RPC_ADDR=nexad:18332
      - ROSTRUM_DAEMON_P2P_ADDR=nexad:18444
      - ROSTRUM_ELECTRUM_RPC_ADDR=0.0.0.0:30401
      - ROSTRUM_ELECTRUM_WS_ADDR=0.0.0.0:30403
      - ROSTRUM_DAEMON_DIR=/nexa-data/.nexa
      - ROSTRUM_AUTH=alice:password

volumes:
  nexa-data:
  rostrum-data:
